import { copy } from '@agile-ts/utils';

var __defProp = Object.defineProperty;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
typeof require !== "undefined" ? require : (x) => {
  throw new Error('Dynamic require of "' + x + '" is not supported');
};
const logCodeTypes = {
  "00": "success",
  "01": "info",
  "02": "warn",
  "03": "error"
};
let allowLogging = true;
const niceLogCodeMessages = {
  "10:00:00": "Created new AgileInstance.",
  "10:02:00": "Be careful when binding multiple Agile Instances globally in one application!",
  "11:02:00": "The 'Local Storage' is not available in your current environment. To use the '.persist()' functionality, please provide a custom Storage!",
  "11:02:01": "The first allocated Storage for AgileTs must be set as the default Storage!",
  "11:03:00": "Storage with the key/name '${0}' already exists!",
  "11:03:01": "Couldn't find Storage '${0}'. The Storage with the key/name '${0}' doesn't exists!",
  "11:03:02": "Storage with the key/name '${0}' isn't ready yet!",
  "11:03:03": "No Storage found to get a value from! Please specify at least one Storage.",
  "11:03:04": "No Storage found to store a value in! Please specify at least one Storage.",
  "11:03:05": "No Storage found to remove a value from! Please specify at least one Storage.",
  "12:03:00": "No valid persist Key found! Provide a valid key or assign one to the parent instance.",
  "12:03:01": "No valid persist Storage Key found! Please specify at least one Storage Key to use the persist functionality.",
  "12:03:02": "Couldn't validate Persistent '${0}'.The Storage with the key/name '${1}' doesn't exists!`",
  "13:00:00": "Registered new Storage '${0}'.",
  "13:01:00": "GET value at key '${1}' from Storage '${0}'.",
  "13:01:01": "SET value at key '${1}' in Storage '${0}'.",
  "13:01:02": "REMOVE value at key '${1}' from Storage '${0}'.",
  "13:02:00": "Using normalGet() in a async-based Storage might result in an unexpected return value. Instead of a resolved value a Promise is returned!",
  "13:03:00": "Invalid Storage '${0}()' method provided!",
  "14:03:01": "'${1}' is a not supported type! Supported types are: String, Boolean, Array, Object, Number.",
  "14:03:02": "The 'patch()' method works only in object based States!",
  "14:03:03": "Only one Interval can be active at once!",
  "14:03:04": "Failed to invert value of the type '${0}'!",
  "15:01:00": "Unregistered 'Callback' based Subscription.",
  "15:01:01": "Unregistered 'Component' based Subscription.",
  "15:01:02": "Registered 'Component' based Subscription.",
  "15:01:03": "Registered 'Callback' based Subscription.",
  "16:01:00": "Created Job '${0}'",
  "16:01:01": "Completed Job '${0}'",
  "16:01:02": "Updated/Rerendered Subscriptions",
  "16:02:00": "SubscriptionContainer/Component '${0}' isn't ready to rerender!",
  "16:02:01": "Job with not ready SubscriptionContainer/Component was removed from the runtime after ${0} tries to avoid a Job overflow.",
  "17:03:00": "The 'perform()' method isn't set in Observer but need to be set! Observer is no stand alone class.",
  "18:00:00": "Integrated '${0}' into AgileTs '${1}'",
  "18:02:00": "Can't call the 'update()' method on a not ready Integration '${0}'!",
  "18:03:00": "Failed to integrate Framework '${0}' into AgileTs '${1}'!",
  "1A:02:00": "Failed to build unique Item StorageKey!",
  "1A:02:01": "Failed to build unique Group StorageKey!",
  "1B:02:00": "We recommend using 'createGroup()' instead of 'Group()' outside the Collection configuration object.",
  "1B:02:01": "We recommend using 'createSelector()' instead of 'Selector()' outside the Collection configuration object.",
  "1B:02:02": "By overwriting the whole Item you have to pass the correct itemKey into the 'changes object!'",
  "1B:02:03": "We recommend using 'Group()' instead of 'createGroup()' inside the Collection configuration object.",
  "1B:02:04": "We recommend using 'Selector()' instead of 'createSelector()' inside the Collection configuration object.",
  "1B:02:05": "Collection '${0}' Item Data has to contain a primaryKey property called '${1}'!",
  "1B:03:00": "Couldn't update Item with the key/name '${0}' because it doesn't exist in Collection '${1}'",
  "1B:03:01": "Valid object required to update Item value '${0}' in Collection '${1}'!",
  "1B:03:02": "Group with the key/name '${0}' already exists!",
  "1B:03:03": "Selector with the key/name '${0}' already exists!",
  "1B:03:04": "Couldn't update ItemKey from '${0}' to '${1}' because an Item with the key/name '${1}' already exists in the Collection '${2}'!",
  "1B:03:05": "Item Data of Collection '${0}' has to be a valid object!",
  "1B:03:06": "Item tried to add to the Collection '${0}' belongs to another Collection '${1}'!",
  "1C:02:00": "Couldn't find some Items in the Collection '${0}' during the rebuild of the Group '${1}' output.",
  "1C:03:00": "The 'output' property of the Group '${0}' is a automatically generated readonly property that can only be mutated by the Group itself!",
  "1C:03:01": "The 'item' property of the Group '${0}' is a automatically generated readonly property that can only be mutated by the Group itself!",
  "20:03:00": "Failed to get Agile Instance from",
  "20:03:01": "Failed to create global Instance at '${0}'",
  "20:03:02": "Required module '${0}' couldn't be retrieved!",
  "00:03:00": "The '${0}()' method isn't set in ${1} but need to be set! ${1} is no stand alone class.",
  "00:03:01": "'${0}' has to be of the type ${1}!"
};
const logCodeMessages = process.env.NODE_ENV !== "production" ? niceLogCodeMessages : {};
function setAllowLogging(logging) {
  allowLogging = logging;
}
function getLog(logCode, replacers = []) {
  let result = logCodeMessages[logCode];
  if (result == null)
    return logCode;
  for (let i = 0; i < replacers.length; i++) {
    result = result.replace("${" + i + "}", replacers[i]);
  }
  return result;
}
function log(logCode, replacers = [], ...data) {
  const logger = LogCodeManager.getLogger();
  if (logger != null && !logger.isActive || !allowLogging)
    return;
  const logType = logCodeTypes[logCode.substr(3, 2)];
  if (typeof logType !== "string")
    return;
  if (logger == null) {
    if (logType === "error" || logType === "warn")
      console[logType](`Agile: ${getLog(logCode, replacers)}`);
    return;
  }
  logger[logType](getLog(logCode, replacers), ...data);
}
function logIfTags(tags, logCode, replacers = [], ...data) {
  const logger = LogCodeManager.getLogger();
  if (logger != null && !logger.isActive || !allowLogging)
    return;
  const logType = logCodeTypes[logCode.substr(3, 2)];
  if (typeof logType !== "string")
    return;
  if (logger == null) {
    return;
  }
  logger.if.tag(tags)[logType](getLog(logCode, replacers), ...data);
}
function assignAdditionalLogs(additionalLogs, logCodeManager) {
  const copiedLogCodeManager = copy(logCodeManager);
  copiedLogCodeManager.logCodeMessages = __spreadValues(__spreadValues({}, copiedLogCodeManager.logCodeMessages), additionalLogs);
  return copiedLogCodeManager;
}
let tempLogCodeManager;
if (process.env.NODE_ENV !== "production") {
  let loggerPackage = null;
  try {
    loggerPackage = require("@agile-ts/logger");
  } catch (e) {
  }
  tempLogCodeManager = {
    getLog,
    log,
    logCodeLogTypes: logCodeTypes,
    logCodeMessages,
    getLogger: () => {
      if (loggerPackage != null)
        return loggerPackage.sharedLogger;
      return null;
    },
    logIfTags,
    setAllowLogging
  };
} else {
  tempLogCodeManager = {
    getLog: (logCode, replacers) => logCode,
    log,
    logCodeLogTypes: logCodeTypes,
    logCodeMessages: {},
    getLogger: () => {
      return null;
    },
    logIfTags: (tags, logCode, replacers) => {
    },
    setAllowLogging
  };
}
const LogCodeManager = tempLogCodeManager;

export { LogCodeManager, assignAdditionalLogs };
